Index: gdm-2.24.0/gui/simple-greeter/gdm-greeter-login-window.c
===================================================================
--- gdm-2.24.0.orig/gui/simple-greeter/gdm-greeter-login-window.c
+++ gdm-2.24.0/gui/simple-greeter/gdm-greeter-login-window.c
@@ -92,6 +92,9 @@
 #define KEY_GREETER_DIR             "/apps/gdm/simple-greeter"
 #define KEY_BANNER_MESSAGE_ENABLED  KEY_GREETER_DIR "/banner_message_enable"
 #define KEY_BANNER_MESSAGE_TEXT     KEY_GREETER_DIR "/banner_message_text"
+#define KEY_LOGO_EDITABLE	    KEY_GREETER_DIR "/logo_info_editable"
+#define KEY_LOGO_NAME_LABEL	    KEY_GREETER_DIR "/logo_info_name_label"
+#define KEY_LOGO_VERSION_LABEL	    KEY_GREETER_DIR "/logo_info_version_label"
 #define KEY_LOGO                    KEY_GREETER_DIR "/logo_icon_name"
 #define KEY_DISABLE_RESTART_BUTTONS KEY_GREETER_DIR "/disable_restart_buttons"
 #define GDM_GREETER_LOGIN_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GDM_TYPE_GREETER_LOGIN_WINDOW, GdmGreeterLoginWindowPrivate))
@@ -1640,23 +1643,55 @@ static void
 create_computer_info (GdmGreeterLoginWindow *login_window)
 {
         GtkWidget *label;
+	GError      *error;
+	gboolean editable;
 
         gdm_profile_start (NULL);
+                
+	error = NULL;
+	editable = gconf_client_get_bool (login_window->priv->client, KEY_LOGO_EDITABLE, &error);
+	if (error != NULL) {
+		editable = FALSE;
+		g_debug ("GdmGreeterLoginWindow: unable to get logo editable setting: %s", error->message);
+		g_error_free (error);
+	}
 
         label = glade_xml_get_widget (login_window->priv->xml, "computer-info-name-label");
         if (label != NULL) {
-                gtk_label_set_text (GTK_LABEL (label), g_get_host_name ());
+		if (editable) {
+			char *name;
+			name = gconf_client_get_string (login_window->priv->client, KEY_LOGO_NAME_LABEL, NULL);
+			if (name && (strlen (name) > 0)) {
+				gtk_label_set_text (GTK_LABEL (label), name);
+				g_free (name);
+			} else {
+				gtk_widget_hide (label);
+			}
+		} else
+	                gtk_label_set_text (GTK_LABEL (label), g_get_host_name ());
         }
 
         label = glade_xml_get_widget (login_window->priv->xml, "computer-info-version-label");
         if (label != NULL) {
                 char *version;
                 char *markup;
-                version = get_system_version ();
-                markup = g_markup_printf_escaped ("<b>%s</b>", version);
-                gtk_label_set_markup (GTK_LABEL (label), markup);
-                g_free (version);
-                g_free (markup);
+		if (editable) {
+			version = gconf_client_get_string (login_window->priv->client, KEY_LOGO_VERSION_LABEL, NULL);
+                        if (version && (strlen (version) > 0)) {
+				markup = g_markup_printf_escaped ("<b>%s</b>", version);
+                                gtk_label_set_markup (GTK_LABEL (label), markup);
+				g_free (version);
+                                g_free (markup);
+                        } else {
+                                gtk_widget_hide (label);                        
+                        }
+		} else {
+	                version = get_system_version ();
+        	        markup = g_markup_printf_escaped ("<b>%s</b>", version);
+                	gtk_label_set_markup (GTK_LABEL (label), markup);
+	                g_free (version);
+        	        g_free (markup);
+		}
         }
 
         gdm_profile_end (NULL);
@@ -1729,12 +1764,24 @@ load_theme (GdmGreeterLoginWindow *login
 
                 g_debug ("GdmGreeterLoginWindow: Got greeter logo '%s'",
                           icon_name ? icon_name : "(null)");
-                if (icon_name != NULL) {
+                if ((icon_name != NULL) && (strlen (icon_name) > 0)){
                         gtk_image_set_from_icon_name (GTK_IMAGE (image),
                                                       icon_name,
                                                       GTK_ICON_SIZE_DIALOG);
                         g_free (icon_name);
-                }
+                } else {
+			gboolean editable;
+			error = NULL;
+			editable = gconf_client_get_bool (login_window->priv->client, KEY_LOGO_EDITABLE, &error);
+			if (error) {
+				editable = FALSE;
+                        	g_debug ("GdmGreeterLoginWindow: unable to get logo editable setting: %s", error->message);
+	                        g_error_free (error);
+			}
+			if (editable) {
+				gtk_widget_hide (image);	
+			}
+		}
         }
 
         box = glade_xml_get_widget (login_window->priv->xml, "window-box");
Index: gdm-2.24.0/gui/simple-greeter/gdm-simple-greeter.schemas.in
===================================================================
--- gdm-2.24.0.orig/gui/simple-greeter/gdm-simple-greeter.schemas.in
+++ gdm-2.24.0/gui/simple-greeter/gdm-simple-greeter.schemas.in
@@ -35,6 +35,39 @@
       </locale>
     </schema>
     <schema>
+      <key>/schemas/apps/gdm/simple-greeter/logo_info_editable</key>
+      <applyto>/apps/gdm/simple-greeter/logo_info_editable</applyto>
+      <owner>gdm-simple-greeter</owner>
+      <type>bool</type>
+      <default>FALSE</default>
+      <locale name="C">
+        <short>Enable editing the logo info</short>
+        <long>Set the true to hide/edit the computer logo_icon/name/version to use for the greeter logo.</long>
+      </locale>
+    </schema>
+    <schema>
+      <key>/schemas/apps/gdm/simple-greeter/logo_info_name_label</key>
+      <applyto>/apps/gdm/simple-greeter/logo_info_name_label</applyto>
+      <owner>gdm-simple-greeter</owner>
+      <type>string</type>
+      <default></default>
+      <locale name="C">
+        <short>Computer name to use for greeter logo</short>
+        <long>Set the computer name info to use for the greeter logo.</long>
+      </locale>
+    </schema>
+    <schema>
+      <key>/schemas/apps/gdm/simple-greeter/logo_info_version_label</key>
+      <applyto>/apps/gdm/simple-greeter/logo_info_version_label</applyto>
+      <owner>gdm-simple-greeter</owner>
+      <type>string</type>
+      <default></default>
+      <locale name="C">
+        <short>Computer version to use for greeter logo</short>
+        <long>Set the computer version info to use for the greeter logo.</long>
+      </locale>
+    </schema>
+    <schema>
       <key>/schemas/apps/gdm/simple-greeter/logo_icon_name</key>
       <applyto>/apps/gdm/simple-greeter/logo_icon_name</applyto>
       <owner>gdm-simple-greeter</owner>